#!/usr/bin/perl
#*******************************************************************#
#  DDNS Updater - 3rdparty DDNS host updater                        #
#  Modul:       force_update.cgi                                    #
#  Description: a perl script to force update of ddns hosts         #
#  Author:      QTip from the german Synology support forum         #
#  Copyright:   2015 by QTip                                        #
#  License:     GNU GPLv3 (see LICENSE)                             #
#  ---------------------------------------------------------------  #
#  Version:     0.1 - 17/03/2015                                    #
#  for more information check the changelog                         #
#*******************************************************************#

$user = `/usr/syno/synoman/webman/modules/authenticate.cgi`;
$user =~ s/^\s+|\s+$//g;
exit if ($user eq '');

use strict;
use warnings;

use FindBin qw($Bin);
use File::Spec;
use lib ("$Bin/../../lib");

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use JSON::XS;
use Fcntl qw(:flock);
#use Data::Dumper;

my @path = File::Spec->splitdir($Bin);
my $configpath = "/var/packages/$path[3]/etc";
my $status_file = "$configpath/status.json";
my $pidfile = "/var/run/ddud.pid";

my (@parts,$part,$buffer,$value,$name,%param);

sub get_pid {
     my $pidfile = shift;

     if (-e $pidfile) {
          if (!open(FD,"<",$pidfile)) {
               return 0;
          } else {
               my $PID = <FD>;
               close(FD);
               return $PID;
          }
     }
     return 0;
}
###################################

print "Content-type: application/json; charset=UTF-8\n\n";

if ($ENV{'REQUEST_METHOD'} eq "POST") {
     read(STDIN,$buffer,$ENV{"CONTENT_LENGTH"});
     @parts = split(/\&/,$buffer);
     foreach $part (@parts) {
          ($name,$value) = split(/=/,$part);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          # prevent include of server side includes
          $value =~ s/<!--(.|\n)*-->//g;
          $param{$name} = $value;
     }
     if ($param{'action'} eq "apply" && $param{'value'} ne "") {
          my $status_data = ({});
          if (-e $status_file) {
               if (open(DAT,"<",$status_file)) {
                    flock(DAT, LOCK_EX);
                    $status_data = <DAT>;
                    close(DAT);
               } else {
                    close(DAT);
                    exit;
               }
          }
          my $status = JSON::XS->new->decode($status_data) if ($status_data);
          my $hosts = JSON::XS->new->decode($param{'value'}) if ($param{'value'});
#print Dumper($hosts);
          map {$status->{$_}{'utime'} = -1 if exists($status->{$_})} @{$hosts->{'hosts'}};
#print Dumper($status);
          my $status_new = JSON::XS->new->encode($status) if ($status);
          if (open(STATUS,">",$status_file)) {
               flock(STATUS, LOCK_EX);
               print STATUS $status_new;
               close (STATUS);
               my $pid = get_pid($pidfile);
               exec("/bin/kill -1 $pid") if ($pid);
               print '{"success":true}';
          } else {
               close (STATUS);
               print '{"success":false}';
          }
     }
}
exit;
