#!/usr/bin/perl
#********************************************************************#
#  DDNS Updater - 3rdparty dynamic ddns updater                      #
#  Modul:       getip.cgi                                            #
#  Description: a perl script to get the current ip from a ajax call #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2015 by QTip                                         #
#  License:     GNU GPLv3 (see LICENSE)                              #
#  ----------------------------------------------------------------  #
#  Version:     0.15 - 03/04/2015                                    #
#  for more information check the changelog                          #
#********************************************************************#

$user = `/usr/syno/synoman/webman/modules/authenticate.cgi`;
$user =~ s/^\s+|\s+$//g;
exit if ($user eq '');

use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

use FindBin qw($Bin);
use lib ("$Bin/../../lib");

use DDNSUpdater::Functions;
use DDNSUpdater::Tools;

## initialize vars #################
my (@parts,$part,$buffer,$value,$name,%param,$raw_data);
my @cpath = File::Spec->splitdir($Bin);
my $packagename = "$cpath[3]";
my $packagehome = "/var/packages/$packagename";
my $configpath = "$packagehome/etc";
my $dsmbuild = `/bin/get_key_value /etc.defaults/VERSION buildnumber`;
chomp($dsmbuild);

$ENV{'PLIENT_HANDLER_PREFERENCE'} = "http:curl;https:curl";
$ENV{'PLIENT_CURL'} = ($dsmbuild >= 4458 ? "/usr/bin/curl" : "/usr/syno/bin/curl");
$ENV{'DDU_DEBUG'} ||= 0;
binmode(STDOUT,":encoding(UTF-8)") if ($ENV{'DDU_DEBUG'});


###################################

print "Content-type: application/json; charset=UTF-8\n\n";

if ($ENV{'REQUEST_METHOD'} eq "POST") {
     read(STDIN,$buffer,$ENV{"CONTENT_LENGTH"});
     @parts = split(/\&/,$buffer);
     foreach $part (@parts) {
          ($name,$value) = split(/=/,$part);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          # prevent include of server side includes
          $value =~ s/<!--(.|\n)*-->//g;
          $param{$name} = $value;
     }
     if ($param{'action'} eq "enum" && $param{'ipsystem'} ne "" && $param{'iptype'} ne "") {
          my $duchecksites = DDNSUpdater::Functions->read_config($configpath."/sites.json");
          my @ipsystem = ($param{'ipsystem'} eq "ipv46") ? ('ipv4','ipv6') : $param{'ipsystem'};
          DDNSUpdater::Tools->get_ip($param{'iptype'},\@ipsystem,\@{$duchecksites->{'sites'}});
          print '{"success":true,"ipv4":"'.(defined $ips->{'ipv4'}?$ips->{'ipv4'}:'').'","ipv6":"'.(defined $ips->{'ipv6'}?$ips->{'ipv6'}:'').'"}';
     }
}
exit;
