#!/usr/bin/perl
#********************************************************************#
#  DDNS Updater - 3rdparty dynamic ddns updater                      #
#  Modul:       getipsystem.cgi                                      #
#  Description: a perl script to get the ip system and ips from a    #
#               ajax call                                            #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2015 by QTip                                         #
#  License:     GNU GPLv3 (see LICENSE)                              #
#  ----------------------------------------------------------------  #
#  Version:     0.1 - 04/04/2015                                     #
#  for more information check the changelog                          #
#********************************************************************#

$user = `/usr/syno/synoman/webman/modules/authenticate.cgi`;
$user =~ s/^\s+|\s+$//g;
exit if ($user eq '');

use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

use FindBin qw($Bin);
use lib ("$Bin/../../lib");

use DDNSUpdater::Functions;
use DDNSUpdater::Tools qw($ips $EOL $useragent);
#use Data::Dumper;

## initialize vars #################
my (@parts,$part,$buffer,$value,$name,%param,$raw_data,$ipsys,$ip4,$ip6);
my $program = "ddud_ipd";
my $version = "0.1";
my $build_date = "20150404";
my @cpath = File::Spec->splitdir($Bin);
my $packagename = "$cpath[3]";
my $packagehome = "/var/packages/$packagename";
my $configpath = "$packagehome/etc";
our $useragent = $program.'/'.$version.'/'.$build_date;
my $dsmbuild = `/bin/get_key_value /etc.defaults/VERSION buildnumber`;
chomp($dsmbuild);

###################################

print "Content-type: application/json; charset=UTF-8\n\n";

if ($ENV{'REQUEST_METHOD'} eq "POST") {
     read(STDIN,$buffer,$ENV{"CONTENT_LENGTH"});
     @parts = split(/\&/,$buffer);
     foreach $part (@parts) {
          ($name,$value) = split(/=/,$part);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          # prevent include of server side includes
          $value =~ s/<!--(.|\n)*-->//g;
          $param{$name} = $value;
     }
     if ($param{'action'} eq "enum") {
          $ip4 = '';
          $ip6 = '';
          my $duchecksites = DDNSUpdater::Functions->read_config($configpath."/sites.json");
          if ($param{'ipsystem'} ne "" && $param{'iptype'} ne "") {
               my @ipsystem = ($param{'ipsystem'} eq "ipv46") ? ('ipv4','ipv6') : $param{'ipsystem'};
               DDNSUpdater::Tools->get_ip($param{'iptype'},\@ipsystem,\@{$duchecksites->{'sites'}},$dsmbuild);
          } else {
               DDNSUpdater::Tools->detect_ip_system(\@{$duchecksites->{'sites'}});
          }
          if (defined $ips->{'ipv4'} && defined $ips->{'ipv6'}) {
               $ipsys = 'ipv46';
               $ip4 = $ips->{'ipv4'};
               $ip6 = $ips->{'ipv6'};
          } elsif (defined $ips->{'ipv4'}) {
               $ipsys = 'ipv4';
               $ip4 = $ips->{'ipv4'};
          } elsif (defined $ips->{'ipv6'}) {
               $ipsys = 'ipv6';
               $ip6 = $ips->{'ipv6'};
          }
          print '{"success":true,"ipsystem":"'.$ipsys.'","ipv4":"'.$ip4.'","ipv6":"'.$ip6.'"}';
     }
}
exit;
