#!/usr/bin/perl
#********************************************************************#
#  DDNS Updater - 3rdparty dynamic ddns updater                      #
#  Modul:       getstatus.cgi                                        #
#  Description: a perl script to read the current status of a daemon #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2013-2015 by QTip                                    #
#  License:     GNU GPLv3 (see LICENSE)                              #
#  ----------------------------------------------------------------  #
#  Version:     0.11 - 14/10/2015                                    #
#  for more information check the changelog                          #
#********************************************************************#

use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

## initialize vars #################
my (@parts,$part,$buffer,$value,$name,%param,$raw_data,$ipsys,$ip4,$ip6);

###################################

print "Content-type: application/json; charset=UTF-8\n\n";

if ($ENV{'REQUEST_METHOD'} eq "POST") {
     read(STDIN,$buffer,$ENV{"CONTENT_LENGTH"});
     @parts = split(/\&/,$buffer);
     foreach $part (@parts) {
          ($name,$value) = split(/=/,$part);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          # prevent include of server side includes
          $value =~ s/<!--(.|\n)*-->//g;
          $param{$name} = $value;
     }
     if ($param{'build'} ne "") {
          my $ps_cmd = ($param{'build'} >= 7135 ? "/bin/ps ax" : "/bin/ps");
          my $pidfile = "/var/run/ddud.pid";
          if (-e $pidfile) {
               my $ps = `$ps_cmd | /bin/grep "ddud" | /bin/grep -v "grep"`;
               $ps =~ s/^\s+//;
#print $ps;
               if ($ps ne "") {
                    if ($ps =~ m/ddud\s-\schecking\shosts/i) {
                         print '{"success":true,"status":"StatusCheckingText","running":true,"next":2}';
                    } elsif ($ps =~ m/ddud\s-\sreloading\sconfig/i) {
                         print '{"success":true,"status":"StatusReloadingText","running":true,"next":2}';
                    } else {
                         $ps =~ /ddud\s-\snext\scheck\sin\s(.*?)\sseconds$/i;
                         my $rs = defined $1 && $1 ne "" ? $1 : '10';
                         print '{"success":true,"status":"StatusRunningText","running":true,"next":'.$rs.'}';
                    }
               } else {
                    print '{"success":true,"status":"StatusRunningErrorText","running":false,"next":10}';
               }
          } else {
               print '{"success":true,"status":"StatusNotRunningText","running":false,"next":10}';
          }
     }
}
exit;
