#!/usr/bin/perl
#********************************************************************#
#  DDNS Updater - 3rdparty dynamic ddns updater                      #
#  Modul:       logfile.cgi                                          #
#  Description: a perl script to read the logfile from a ajax call   #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2014-2015 by QTip                                    #
#  License:     GNU GPLv3 (see LICENSE)                              #
#  ----------------------------------------------------------------  #
#  Version:     0.15 - 15/03/2014                                    #
#  for more information check the changelog                          #
#********************************************************************#

$user = `/usr/syno/synoman/webman/modules/authenticate.cgi`;
$user =~ s/^\s+|\s+$//g;
exit if ($user eq '');

use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

## initialize vars #################
my (@parts,$part,$buffer,$value,$name,%param,$raw_data);
my $logfile = "/var/log/ddud.log";

###################################

print "Content-type: application/json; charset=UTF-8\n\n";

if ($ENV{'REQUEST_METHOD'} eq "POST") {
     read(STDIN,$buffer,$ENV{"CONTENT_LENGTH"});
     @parts = split(/\&/,$buffer);
     foreach $part (@parts) {
          ($name,$value) = split(/=/,$part);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          # prevent include of server side includes
          $value =~ s/<!--(.|\n)*-->//g;
          $param{$name} = $value;
     }
     if ($param{'action'} eq "read") {
          my $search = '';
          my $error = '';
          if ($param{'search'} ne "") {
               $search = " | /bin/grep -A2 -B2 -E '".$param{'search'}."'";
               $error = "search pattern $param{'search'} not found";
          }
          my $logdata = `set IFS='%' && (/bin/cat $logfile | /bin/grep -v grep $search) >&1`;
#               $logdata =~ s/ / /g;
          my @log = split(/\x0A/,$logdata);
          if ($? == 0) {
               if ($param{'dir'} eq "asc") {
                    print join("\x0A",@log);
               } elsif ($param{'dir'} eq "desc") {
                    print join("\x0A",reverse(@log));
               }
          } else {
               print $error;
          }
     }
}
exit;
