#!/usr/bin/perl
#********************************************************************#
#  DDNS Updater - 3rdparty dynamic ddns updater                      #
#  Modul:       index.cgi                                            #
#  Description: perl start script of ddns updater                    #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2014-2016 by QTip                                    #
#  License:     GNU GPLv3 (see LICENSE)                              #
#  ----------------------------------------------------------------  #
#  Version:     0.52 - 20/06/2016                                    #
#  for more information check the changelog                          #
#********************************************************************#

use strict;
use warnings;

use FindBin qw($Bin);
use lib ("$Bin/include","$Bin/../lib");

use CGI;
use CGI::Carp qw(fatalsToBrowser);

require "check_appprivilege.pl";
my ($synotoken,$synouser,$is_admin) = check_privilege('SYNO.SDS._ThirdParty.App.ddnsupdater2');
# if it return a empty string (not logged in), then exit app
exit if ($synouser eq '');

use DDNSUpdater::Functions;
#use Data::Dumper;

my $dsm = '';
my $theme = 'default';
my $firststart = 0;
my $lastmessage = '';
my $smallfixnumber = `/bin/get_key_value /etc.defaults/VERSION smallfixnumber`;
chomp($smallfixnumber);
my $dsmmajor = `/bin/get_key_value /etc.defaults/VERSION majorversion`;
chomp($dsmmajor);
my $dsmminor = `/bin/get_key_value /etc.defaults/VERSION minorversion`;
chomp($dsmminor);
my $dsmbuild = `/bin/get_key_value /etc.defaults/VERSION buildnumber`;
chomp($dsmbuild);
my $dsmversion = $dsmmajor.'.'.$dsmminor.'.'.$dsmbuild;
$dsmversion = ($smallfixnumber ne "") ? $dsmversion.'-'.$smallfixnumber : $dsmversion;
my $dsmtheme = `/bin/get_key_value /etc/synoinfo.conf theme`;
chomp($dsmtheme);
$dsm = '5' if ($dsmmajor >= 5);
$theme = ($dsmtheme eq "business" ? '-dark':'');
my $dumajor = `/bin/get_key_value $Bin/VERSION MAJOR`;
chomp($dumajor);
my $duminor = `/bin/get_key_value $Bin/VERSION MINOR`;
chomp($duminor);
my $dubuild = `/bin/get_key_value $Bin/VERSION BUILD`;
chomp($dubuild);
my $dsmlanguage = DDNSUpdater::Functions->get_language($synouser);
my $dsmhostname = lc(`/bin/hostname`);
chomp($dsmhostname);
$firststart = 1 if (-e "/var/packages/ddnsupdater2/target/firststart");
$firststart = 2 if ($firststart && -e "/var/packages/ddnsupdater/target/VERSION");
unlink ("/var/packages/ddnsupdater2/target/firststart") if ($firststart);

$dsmlanguage = "enu" unless (-e $Bin.'/texts/'.$dsmlanguage.'/gui.js');
opendir(DIR,"$Bin/texts");
my @dirs = grep(!/^\./,readdir(DIR));
closedir(DIR);
my $dulanguages = join(" ",sort(@dirs));

my $dumodules = '[]';
my $moduledata = DDNSUpdater::Functions->read_config("/var/packages/ddnsupdater2/etc/modules.json");
if (defined $moduledata) {
     $dumodules = '';
     map {$dumodules .= '["'.$_.'"],'} @{$moduledata->{'modules'}};
     $dumodules = substr($dumodules,0,-1);
}
if (-d "/var/packages/ddnsupdater2/target/tmp") {unlink glob("/var/packages/ddnsupdater2/target/tmp/*");};

print "Content-type: text/html; charset=UTF-8\n\n";

print <<EOTBEGIN;
<!DOCTYPE html>
<html>
<head>
     <meta http-equiv="X-UA-Compatible" content="IE=9">
     <meta http-equiv="pragma" content="no-cache"><meta http-equiv="expires" content="-1"><meta http-equiv="cache-control" content="no-cache">
EOTBEGIN

     print "<link rel='stylesheet' type='text/css' href='extjs/resources/css/ext-all.css?v=".$dubuild."'>";
     print "<link rel='stylesheet' type='text/css' href='extjs/resources/css/xtheme-dsm".$dsm.$theme.".css?v=".$dubuild."'>";
     print "<link rel='stylesheet' type='text/css' href='scripts/statusbar".$dsm.$theme.".css?v=".$dubuild."'>";
     print "<link rel='stylesheet' type='text/css' href='scripts/fileuploadfield.css?v=".$dubuild."'>";
     print "<link rel='stylesheet' type='text/css' href='scripts/ddnsupdater".$dsm.$theme.".css?v=".$dubuild."'>";

print <<EOTBEGIN;
     <link rel="shortcut icon" href="favicon.ico">
     <script type="text/javascript" src="extjs/adapter/ext/ext-base.js?v=$dubuild"></script>
     <script type="text/javascript" src="extjs/ext-all.js?v=$dubuild"></script>
     <script type="text/javascript" src="extjs/ext-fix_3.4.1.1.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/fuzzyset.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/CheckColumn.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/StatusBar.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/Ext.ux.PanelCollapsedTitle.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/FileUploadField.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/punycode.min.js?v=$dubuild"></script>
     <script type="text/javascript" src="scripts/general_functions.js?v=$dubuild"></script>
     <script language="javascript" type="text/javascript">
          Ext.ns('DDNS.Updater');
          DDNS.Updater.languages = '$dulanguages';
          DDNS.Updater.synotoken = '$synotoken';
          DDNS.Updater.dsmmajor = '$dsmmajor';
          DDNS.Updater.dsmbuild = '$dsmbuild';
          DDNS.Updater.dubuild = '$dubuild';
          DDNS.Updater.smallfixnumber = '$smallfixnumber';
          DDNS.Updater.spkver = '$dumajor.$duminor-$dubuild';
          DDNS.Updater.server_ip = '$ENV{SERVER_ADDR}';
          DDNS.Updater.firststart = '$firststart';
          Ext.ns('DDNS.Updater.Modules');
          DDNS.Updater.Modules.values = [$dumodules];
          Ext.ns('DDNS.Updater');

     </script>
EOTBEGIN

     print "<script type='text/javascript' src='extjs/locale/ext-lang-".DDNSUpdater::Functions->convert_syno2iso($dsmlanguage).".js?v=".$dubuild."'></script>";
     print "<script type='text/javascript' src='texts/$dsmlanguage/gui.js?v=".$dubuild."'></script>";
     print "<script type='text/javascript' src='scripts/functions.js?v=".$dubuild."'></script>";
     print "<script type='text/javascript' src='scripts/ddnsapp.js?v=".$dubuild."'></script>";
     print "<script type='text/javascript' src='scripts/ddnsupdater.js?v=".$dubuild."'></script>";

print <<EOTEND;
</head><title>DDNS Updater</title><body>
<script language="javascript" type="text/javascript">
document.getElementsByTagName("body")[0].style.cursor = 'auto';
</script></body></html>
EOTEND
