#!/usr/bin/perl
#*******************************************************************#
#  DDNS Updater - 3rdparty DDNS host updater                        #
#  Modul:       set_permissions.pl                                  #
#  Description: a perl script to set file and folder permissions    #
#  Author:      QTip from the german Synology support forum         #
#  Copyright:   2015 by QTip                                        #
#  License:     GNU GPLv3 (see LICENSE)                             #
#  ---------------------------------------------------------------  #
#  Version:     0.1 - 16/03/2015                                    #
#  for more information check the changelog                         #
#*******************************************************************#

use strict;
use warnings;

my $duhome = "/var/packages/ddnsupdater2/target";
my $duetc = "/var/packages/ddnsupdater2/etc";

sub set_permissions {
     my $path = shift;

     opendir(my $handle, $path) or die $!;
     while(my $e = readdir($handle)) {
          next if ($e =~ /^(\.\.?|\.svn|tmp|log)$/);
          chown(0,0,"$path/$e");
          if(-d "$path/$e") {
              chmod(0755,"$path/$e");
              set_permissions("$path/$e");
          } elsif ($e =~ /^(ddud|.*\.pl|.*\.cgi|.*\.sh)$/) {
              chmod(0755,"$path/$e");
          } else {
              chmod(0644,"$path/$e");
          }
     }
     closedir($handle);
}
set_permissions($duhome);
set_permissions($duetc);
exit;
