#!/usr/bin/perl
#*******************************************************************#
#  DDNS Updater - 3rdparty DDNS host updater                        #
#  Modul:       update.pl                                           #
#  Description: a perl script to update data after update of        #
#               DDNS Updater 2.xx                                   #
#  Author:      QTip from the german Synology support forum         #
#  Copyright:   2015-2016 by QTip                                   #
#  License:     GNU GPLv3 (see LICENSE)                             #
#  ---------------------------------------------------------------  #
#  Version:     0.11 - 05/05/2016                                   #
#  for more information check the changelog                         #
#*******************************************************************#

use strict;
use warnings;

use FindBin qw($Bin);
use File::Spec;
use lib ("$Bin/../lib");

use DDNSUpdater::Logger;
use DDNSUpdater::Import;
#use Data::Dumper;

my @path = File::Spec->splitdir($Bin);
my $configpath = "/var/packages/$path[3]/etc";
my $updatepath = "/var/packages/$path[3]/target/etc";

my ($sum,$retjson);
my $result = {'result' => []};

my @imp = glob($updatepath."/*.json");
my $err = 0;
foreach my $file (@imp) {
     if (-f $file && index($file,"modules.json") == -1) {
          $sum = ();
          $retjson = 0;
          ($retjson,$sum) = DDNSUpdater::Import->import($configpath,$file,0,1);
          push(@{$result->{'result'}},\%$sum);
          $err++ if ($retjson > 0);
     }
}
if ($err) {
     foreach my $r (@{$result->{'result'}}) {
          if ($r->{'msg'}) {
               error("file: ".$r->{'file'}.", msg: ".$r->{'msg'});
          }
     }
     error("DDNS Updater 2.xx configuration update failed, see failed files below!");
} else {
     info("DDNS updater 2.xx configuration update successfully!");
}
exit;
