#********************************************************************#
#  DDNS Updater - 3rdparty dynamic ddns updater                      #
#  Modul:       CryptDecrypt.pm                                      #
#  Description: simple encrypt and decrypt functions using openssl   #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2013-2015 by QTip                                    #
#  License:     BSD-style license (see LICENSE)                      #
#  ----------------------------------------------------------------  #
#  Version:     0.3 - 15/10/2015                                     #
#  for more information check the changelog                          #
#********************************************************************#

package DDNSUpdater::CryptDecrypt;

use strict;
use warnings;

use base qw(Exporter);

our $VERSION     = '0.3';
our @EXPORT      = qw();
our @EXPORT_OK   = qw(encrypt_data decrypt_data);
my $dsmbuild = `/bin/get_key_value /etc.defaults/VERSION buildnumber`;
chomp($dsmbuild);
my $openssl_cmd = ($dsmbuild >= 7135 ? "/usr/bin/openssl" : "/usr/syno/bin/openssl");

sub encrypt_data {
     my $class = shift;
     my ($data,$type,$pass) = @_;

     $type ||= 'aes-128-cbc';
     $pass ||= `cat /proc/sys/kernel/syno_serial`;
     chomp($pass);
     return '' unless (defined $data || defined $pass);

     my $hash = '';
     $hash = `echo '$data' | $openssl_cmd enc -$type -a -salt -pass pass:$pass 2> /dev/null`;
     chomp ($hash);
     return (defined $hash ? $hash : '');
}
sub decrypt_data {
     my $class = shift;
     my ($hash,$type,$pass) = @_;

     $type ||= 'aes-128-cbc';
     $pass ||= `cat /proc/sys/kernel/syno_serial`;
     chomp($pass);
     return '' unless (defined $hash || defined $pass);

     my $data = '';
     $data = `echo '$hash' | $openssl_cmd enc -$type -a -d -salt -pass pass:$pass 2> /dev/null`;
     chomp ($data);
     return (defined $data ? $data : '');
}
1;